-- Bootloader
-- This script is only responsible for killing rednet and jumping to the kernel

-- based on some code rph wrote and gave me

if settings.get("snowier.auto_update") then
  local defaultRoot = "https://git.colon-three.com/kodi/snowier/raw/branch/main/"
  local repoRoot = settings.get("snowier.repo_base") or defaultRoot

  shell.run("wget run " .. repoRoot .. "install.lua")
end

local function main()
  if not _G["rednet"] then
    return
  end

  local o = os.pullEventRaw

  os.pullEventRaw = function()
    local a = table.pack(o())
    if a[1] == "modem_message" then
      if string.match(debug.traceback(), "/rom/apis/rednet.lua") then
        print("[D] Rednet called os.pullEventRaw, crashing")
        error("nya")
      end
    end
    return table.unpack(a)
  end

  local p = _G.printError

  _G.printError = function()
    print("[D] Got printError call, cleaning and jumping to kernel")
    _G.printError = p
    _G.os.pullEventRaw = o
    _G["rednet"] = nil
    os.run({
      -- This is an odd hack. We should look into not doing this to run the kernel.
      ["require"]=require
    }, "/kernel/entry.lua")
  end

  print("[D] Queueing bogus modem message")
  os.queueEvent("modem_message")
end

main()
